/*
 * Copyright (C) 2012 Freescale Semiconductor, Inc. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/* This file was modified by BAM Labs, Inc.
 * Original file was board-mx6sl_common.h
 *
 * Establishes board configuration for i.MX6 BAM Labs Sleep Expert.
 */

#ifndef _BOARD_BAMSE_H
#define _BOARD_BAMSE_H
#include <mach/iomux-mx6sl.h>

#define BAMSE_RESET_TEST	IMX_GPIO_NR(3, 18)      /* WDOG_B */
#define BAMSE_WLAN_LSHIFT_OE	IMX_GPIO_NR(3, 24)      /* KEY_COL0 */
#define BAMSE_BT_ENABLE		IMX_GPIO_NR(3, 26)      /* KEY_COL1 */
#define BAMSE_WLAN_ENABLE	IMX_GPIO_NR(3, 27)      /* KEY_ROW1 */
#define BAMSE_WLAN_IRQ		IMX_GPIO_NR(3, 28)      /* KEY_COL2 */

#define BAMSE_USBOTG1_PWR	IMX_GPIO_NR(4, 0)       /* KEY_COL4 */
#define BAMSE_USBOTG2_PWR	IMX_GPIO_NR(4, 2)       /* KEY_COL5 */
#define BAMSE_LCD_PWR_EN	IMX_GPIO_NR(4, 3)	/* KEY_ROW5 */
#define BAMSE_SD1_WP		IMX_GPIO_NR(4, 6)	/* KEY_COL7 */
#define BAMSE_SD1_CD		IMX_GPIO_NR(4, 7)	/* KEY_ROW7 */
#define BAMSE_ECSPI1_CS0	IMX_GPIO_NR(4, 11)	/* ECSPI1_SS0 */
#define BAMSE_HEADPHONE_DET	IMX_GPIO_NR(4, 19)	/* FEC_RX_ER */
#define BAMSE_SD2_WP		IMX_GPIO_NR(4, 29)	/* SD2_DAT6 */
#define BAMSE_SD2_CD		IMX_GPIO_NR(5, 0)	/* SD2_DAT7 */
#define BAMSE_SD3_CD		IMX_GPIO_NR(3, 22)	/* REF_CLK_32K */

static iomux_v3_cfg_t bamse_brd_pads[] = {

#ifdef MAYBE_SOMEDAY
	/* AUDMUX */
	MX6SL_PAD_AUD_TXC__AUDMUX_AUD3_TXC,
	MX6SL_PAD_AUD_TXD__AUDMUX_AUD3_TXD,
	MX6SL_PAD_AUD_TXFS__AUDMUX_AUD3_TXFS,
	MX6SL_PAD_AUD_RXD__AUDMUX_AUD3_RXD,
	MX6SL_PAD_AUD_MCLK__AUDMUX_AUDIO_CLK_OUT,
#endif

#if 0
	/* Audio Codec */
	MX6SL_PAD_FEC_RX_ER__GPIO_4_19,	/* HEADPHONE_DET */

	/* SPDIF TX */
	MX6SL_PAD_SD2_DAT4__SPDIF_OUT1,
#endif

	/* UART1 */
	MX6SL_PAD_UART1_RXD__UART1_RXD,
	MX6SL_PAD_UART1_TXD__UART1_TXD,

	/* USBOTG ID pin */
//	MX6SL_PAD_EPDC_PWRCOM__ANATOP_USBOTG1_ID,
	MX6SL_PAD_LCD_DAT1__ANATOP_USBOTG1_ID,

#if 0
	/* USBOTG POWER GPIO */
	MX6SL_PAD_KEY_COL4__GPIO_4_0,
	MX6SL_PAD_KEY_COL5__GPIO_4_2,
	/* USB OC pin */
	MX6SL_PAD_KEY_ROW4__USB_USBOTG1_OC,
	MX6SL_PAD_ECSPI2_SCLK__USB_USBOTG2_OC,
	/* USB HSIC pin */
	MX6SL_PAD_HSIC_STROBE__USB_H_STROBE,
	MX6SL_PAD_HSIC_DAT__USB_H_DATA,
#endif

	/* SD1 */
	MX6SL_PAD_SD1_CLK__USDHC1_CLK_50MHZ,
	MX6SL_PAD_SD1_CMD__USDHC1_CMD_50MHZ,
	MX6SL_PAD_SD1_DAT0__USDHC1_DAT0_50MHZ,
	MX6SL_PAD_SD1_DAT1__USDHC1_DAT1_50MHZ,
	MX6SL_PAD_SD1_DAT2__USDHC1_DAT2_50MHZ,
	MX6SL_PAD_SD1_DAT3__USDHC1_DAT3_50MHZ,
	MX6SL_PAD_SD1_DAT4__USDHC1_DAT4_50MHZ,
	MX6SL_PAD_SD1_DAT5__USDHC1_DAT5_50MHZ,
	MX6SL_PAD_SD1_DAT6__USDHC1_DAT6_50MHZ,
	MX6SL_PAD_SD1_DAT7__USDHC1_DAT7_50MHZ,
	/* SD1 CD & WP */
	MX6SL_PAD_KEY_ROW7__GPIO_4_7,
	MX6SL_PAD_KEY_COL7__GPIO_4_6,
	/* SD2 */
	MX6SL_PAD_SD2_CLK__USDHC2_CLK_50MHZ,
	MX6SL_PAD_SD2_CMD__USDHC2_CMD_50MHZ,
	MX6SL_PAD_SD2_DAT0__USDHC2_DAT0_50MHZ,
	MX6SL_PAD_SD2_DAT1__USDHC2_DAT1_50MHZ,
	MX6SL_PAD_SD2_DAT2__USDHC2_DAT2_50MHZ,
	MX6SL_PAD_SD2_DAT3__USDHC2_DAT3_50MHZ,
	/* SD2 CD & WP */
	MX6SL_PAD_SD2_DAT7__GPIO_5_0,
	MX6SL_PAD_SD2_DAT6__GPIO_4_29,
	/* SD3 */
	MX6SL_PAD_SD3_CLK__USDHC3_CLK_50MHZ,
	MX6SL_PAD_SD3_CMD__USDHC3_CMD_50MHZ,
	MX6SL_PAD_SD3_DAT0__USDHC3_DAT0_50MHZ,
	MX6SL_PAD_SD3_DAT1__USDHC3_DAT1_50MHZ,
	MX6SL_PAD_SD3_DAT2__USDHC3_DAT2_50MHZ,
	MX6SL_PAD_SD3_DAT3__USDHC3_DAT3_50MHZ,
	/* SD3 CD */
//	MX6SL_PAD_REF_CLK_32K__GPIO_3_22,

#if 0
	/* FEC */
	MX6SL_PAD_FEC_MDC__FEC_MDC,
	MX6SL_PAD_FEC_MDIO__FEC_MDIO,
	MX6SL_PAD_FEC_REF_CLK__FEC_REF_OUT, /* clock from anatop */
	MX6SL_PAD_FEC_RX_ER__GPIO_4_19,
	MX6SL_PAD_FEC_CRS_DV__FEC_RX_DV,
	MX6SL_PAD_FEC_RXD0__FEC_RDATA_0,
	MX6SL_PAD_FEC_RXD1__FEC_RDATA_1,
	MX6SL_PAD_FEC_TX_EN__FEC_TX_EN,
	MX6SL_PAD_FEC_TXD0__FEC_TDATA_0,
	MX6SL_PAD_FEC_TXD1__FEC_TDATA_1,
	MX6SL_PAD_FEC_TX_CLK__GPIO_4_21, /* Phy power enable */
#endif

	/* I2C */
	MX6SL_PAD_I2C1_SCL__I2C1_SCL,
	MX6SL_PAD_I2C1_SDA__I2C1_SDA,
	MX6SL_PAD_I2C2_SCL__I2C2_SCL,
	MX6SL_PAD_I2C2_SDA__I2C2_SDA,

	/* ECSPI1 */
	MX6SL_PAD_ECSPI1_MISO__ECSPI1_MISO,
	MX6SL_PAD_ECSPI1_MOSI__ECSPI1_MOSI,
	MX6SL_PAD_ECSPI1_SCLK__ECSPI1_SCLK,
	MX6SL_PAD_ECSPI1_SS0__ECSPI1_SS0,
	MX6SL_PAD_ECSPI1_SS0__GPIO_4_11,	/* SS0 */

#if 0
	/* LCD */
	MX6SL_PAD_LCD_CLK__LCDIF_CLK,
	MX6SL_PAD_LCD_ENABLE__LCDIF_ENABLE,
	MX6SL_PAD_LCD_HSYNC__LCDIF_HSYNC,
	MX6SL_PAD_LCD_VSYNC__LCDIF_VSYNC,
	MX6SL_PAD_LCD_RESET__LCDIF_RESET,
	MX6SL_PAD_LCD_DAT0__LCDIF_DAT_0,
	MX6SL_PAD_LCD_DAT1__LCDIF_DAT_1,
	MX6SL_PAD_LCD_DAT2__LCDIF_DAT_2,
	MX6SL_PAD_LCD_DAT3__LCDIF_DAT_3,
	MX6SL_PAD_LCD_DAT4__LCDIF_DAT_4,
	MX6SL_PAD_LCD_DAT5__LCDIF_DAT_5,
	MX6SL_PAD_LCD_DAT6__LCDIF_DAT_6,
	MX6SL_PAD_LCD_DAT7__LCDIF_DAT_7,
	MX6SL_PAD_LCD_DAT8__LCDIF_DAT_8,
	MX6SL_PAD_LCD_DAT9__LCDIF_DAT_9,
	MX6SL_PAD_LCD_DAT10__LCDIF_DAT_10,
	MX6SL_PAD_LCD_DAT11__LCDIF_DAT_11,
	MX6SL_PAD_LCD_DAT12__LCDIF_DAT_12,
	MX6SL_PAD_LCD_DAT13__LCDIF_DAT_13,
	MX6SL_PAD_LCD_DAT14__LCDIF_DAT_14,
	MX6SL_PAD_LCD_DAT15__LCDIF_DAT_15,
	MX6SL_PAD_LCD_DAT16__LCDIF_DAT_16,
	MX6SL_PAD_LCD_DAT17__LCDIF_DAT_17,
	MX6SL_PAD_LCD_DAT18__LCDIF_DAT_18,
	MX6SL_PAD_LCD_DAT19__LCDIF_DAT_19,
	MX6SL_PAD_LCD_DAT20__LCDIF_DAT_20,
	MX6SL_PAD_LCD_DAT21__LCDIF_DAT_21,
	MX6SL_PAD_LCD_DAT22__LCDIF_DAT_22,
	MX6SL_PAD_LCD_DAT23__LCDIF_DAT_23,
	/* LCD brightness */
	MX6SL_PAD_PWM1__PWM1_PWMO,
	/* LCD power on */
	MX6SL_PAD_KEY_ROW5__GPIO_4_3,

	/* keypad on E-Ink add-on board */
	MX6SL_PAD_KEY_COL0__KPP_COL_0,
	MX6SL_PAD_KEY_COL1__KPP_COL_1,
	MX6SL_PAD_KEY_COL2__KPP_COL_2,
	MX6SL_PAD_KEY_COL3__KPP_COL_3,
	MX6SL_PAD_KEY_ROW0__KPP_ROW_0,
	MX6SL_PAD_KEY_ROW1__KPP_ROW_1,
	MX6SL_PAD_KEY_ROW2__KPP_ROW_2,
	MX6SL_PAD_KEY_ROW3__KPP_ROW_3,
#else
	MX6SL_PAD_KEY_COL0__GPIO_3_24,	/* WiFi level shifter OE */
	MX6SL_PAD_KEY_ROW0__GPIO_3_25,	/* Debug LED */
	MX6SL_PAD_KEY_COL1__GPIO_3_26,	/* BT Enable */
	MX6SL_PAD_KEY_ROW1__GPIO_3_27,	/* WLAN Enable */
	MX6SL_PAD_KEY_COL2__GPIO_3_28,	/* WLAN IRQ */
#endif

#if 1
	/* WDOG */
	MX6SL_PAD_WDOG_B__WDOG1_WDOG_B,
#else
	/* Reset test. */
	MX6SL_PAD_WDOG_B__GPIO_3_18,
#endif

#if 0
	/* Charge */
	MX6SL_PAD_ECSPI2_MISO__GPIO_4_14,  /* CHG_FLT */
	MX6SL_PAD_ECSPI2_SS0__GPIO_4_15, /* CHG_STATUS */
	MX6SL_PAD_ECSPI2_MOSI__GPIO_4_13, /* CHG_UOK ,CHG_DOK*/
#endif
};

#define MX6SL_USDHC_8BIT_PAD_SETTING(id, speed)	\
mx6sl_sd##id##_##speed##mhz[] = {		\
	MX6SL_PAD_SD##id##_CLK__USDHC##id##_CLK_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_CMD__USDHC##id##_CMD_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT0__USDHC##id##_DAT0_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT1__USDHC##id##_DAT1_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT2__USDHC##id##_DAT2_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT3__USDHC##id##_DAT3_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT4__USDHC##id##_DAT4_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT5__USDHC##id##_DAT5_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT6__USDHC##id##_DAT6_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT7__USDHC##id##_DAT7_##speed##MHZ,	\
}
#define MX6SL_USDHC_4BIT_PAD_SETTING(id, speed)	\
mx6sl_sd##id##_##speed##mhz[] = {		\
	MX6SL_PAD_SD##id##_CLK__USDHC##id##_CLK_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_CMD__USDHC##id##_CMD_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT0__USDHC##id##_DAT0_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT1__USDHC##id##_DAT1_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT2__USDHC##id##_DAT2_##speed##MHZ,	\
	MX6SL_PAD_SD##id##_DAT3__USDHC##id##_DAT3_##speed##MHZ,	\
}


static iomux_v3_cfg_t MX6SL_USDHC_8BIT_PAD_SETTING(1, 50);
static iomux_v3_cfg_t MX6SL_USDHC_8BIT_PAD_SETTING(1, 100);
static iomux_v3_cfg_t MX6SL_USDHC_8BIT_PAD_SETTING(1, 200);
static iomux_v3_cfg_t MX6SL_USDHC_4BIT_PAD_SETTING(2, 50);
static iomux_v3_cfg_t MX6SL_USDHC_4BIT_PAD_SETTING(2, 100);
static iomux_v3_cfg_t MX6SL_USDHC_4BIT_PAD_SETTING(2, 200);
static iomux_v3_cfg_t MX6SL_USDHC_4BIT_PAD_SETTING(3, 50);
static iomux_v3_cfg_t MX6SL_USDHC_4BIT_PAD_SETTING(3, 100);
static iomux_v3_cfg_t MX6SL_USDHC_4BIT_PAD_SETTING(3, 200);

#endif
