/*
 * (C) Copyright 2002-2008
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/* This file was modified by BAM Labs, Inc.
 *
 * Defined the firmware environment settings
 */

/*
 * To build the utility with the run-time configuration
 * uncomment the next line.
 * See included "fw_env.config" sample file (TRAB board)
 * for notes on configuration.
 */
#define CONFIG_FILE     "/etc/fw_env.config"

#define CONFIG_ENV_IS_IN_MMC 1

//#define HAVE_REDUND /* For systems with 2 env sectors */
#define DEVICE1_NAME      "/dev/mmcblk0"
//#define DEVICE2_NAME      "/dev/mtd2"
#define DEVICE1_OFFSET    0xc0000
#define ENV1_SIZE         0x8000
#define DEVICE1_ESIZE     0x8000
//#define DEVICE2_OFFSET    0x0000
//#define ENV2_SIZE         0x4000
//#define DEVICE2_ESIZE     0x4000

#define CONFIG_BAUDRATE		115200
#define CONFIG_BOOTDELAY	3	/* autoboot after 5 seconds	*/
#define CONFIG_LOADADDR		0x80800000	/* loadaddr env var */
#define CONFIG_BOOTCOMMAND "run bootcmd_mmc"

#define	CONFIG_EXTRA_ENV_SETTINGS					\
		"linux_mmcdev=0\0"				\
		"boot_mmcdev=1\0"		\
		"initrd_size=0x7000\0"		\
		"bootargs_base=setenv bootargs console=ttymxc0,115200\0" \
		"bootargs_mmc=setenv bootargs ${bootargs} root=/dev/mmcblk${linux_mmcdev}p1 rootwait\0" \
		"bootcmd_mmc=run bootargs_base bootargs_mmc; mmc dev ${boot_mmcdev}; mmc read ${loadaddr} 0x800 ${initrd_size}; bootm\0"

extern int   fw_printenv(int argc, char *argv[]);
extern char *fw_getenv  (char *name);
extern int fw_setenv  (int argc, char *argv[]);

extern unsigned	long  crc32	 (unsigned long, const unsigned char *, unsigned);
